$compile unit

$error all-
$lib all-
'
'  Demo using PowerBasic 2.10 Directory command along with using the DTA
'  area to get extended file information.
'

'OPTION BASE 1


'DIM UDir$(1:255)

'Path$ = COMMAND$
'IF Path$ = "" THEN
'  Path$ = "*.*"
'END IF
'CLS
'N% = 0
'CALL JJDir(Path$, UDir$(),N%,"Y")

'FOR J% = 1 TO N%
'LPRINT UDIR$(J%)
'NEXT J%

'LPRINT USING "Number of Files: ###,###,###"; N%

'STOP


'
' Ŀ
'                                                                      
'  Function Name:  GetDirectory                                        
'  Date.........:  90/11/16                                            
'                                                                      
'  Description..:  Reads the directory specified by the user and       
'                  returns an array of the files found.                
'                                                                      
' 
'
'   Modified.....:  91/03/19
'   BY JAMES JARVIS
'
'
SUB JJDir(Path$, FileInfo$(), NumFiles%, S$) PUBLIC

'  The parameters for the sub-routine are as follows:
'
'        Path$            - The file path
'
'
'        FileInfo$()      - The files found.
'
'        FILEDate$()      - The Date for each file found
'
'        FILETIME$()      - THE TIME OF EACH FILE FOUND
'
'        FISize&(r)     -  The size in bytes of each file.
'
'        NumFiles%       - The number of files found in the directory
'                          specified by PATH$
'
'

'Ŀ
'			      REGNAMES.INC				     
'									     
' This file is to be used as a $INCLUDE file whenever you use the CALL      
' INTERRUPT statement in your PowerBASIC program. The file contains         
' named constants that represent the registers the CALL INTERRUPT statement 
' can manipulate.							     
'									     
' In order to use this file include it in your programs using the $INCLUDE  
' metastatement:                                          		     
'	                                                            	     
'   $INCLUDE "REGNAMES.INC"						     
'	                                  				     
'

%FLAGS = 0
%AX    = 1
%BX    = 2
%CX    = 3
%DX    = 4
%SI    = 5
%DI    = 6
%BP    = 7
%DS    = 8
%ES    = 9



LOCAL DTADate&
LOCAL DTAOFS&
LOCAL DTASEG&
LOCAL DTASize&
LOCAL DTATime&
LOCAL FDate%
LOCAL FF$
LOCAL FTHour%
LOCAL FTime%
LOCAL LowB%
LOCAL UpprB%
LOCAL FIDateH%
LOCAL HOURS$
LOCAL FIDateM%
LOCAL MINUTES$
LOCAL FIDateS%
LOCAL FIDateY%
LOCAL FIDateD%
LOCAL FILEDATE$
LOCAL FILETIME$
LOCAL FISIZE&


'
' Get the lower and upper bound for all of the arrays used.  I am assuming
' that all arrays are defined with the same lower and upper bound ranges.
'

  LowB%  = LBOUND(FileInfo$(1))
  UpprB% = UBOUND(FileInfo$(1))


  FF$=DIR$(Path$)

'
'   Make a call to get the DTA on the file just read in.  I moved this code
'   to outside the loop as I only have to get the address once!
'
  REG %AX, &H2F00
  CALL INTERRUPT &H21

  DTASEG& = REG(%ES)
  DTAOFS& = REG(%BX)
  DTASize& = DTAOFS& + 26
  DTADate& = DTAOFS& + 24
  DTATIME& = DTAOFS& + 22

  DO WHILE (LEN(FF$) > 0%  AND  LowB% <= UpprB%)

    DEF SEG = DTASEG&
      FISize&        = PEEKL(DTASize&)
      FDate%         = PEEKI(DTADate&)
      FTime%         = PEEKI(DTATime&)
    DEF SEG

'    FileInfo$(LowB%) = FF$

    FIDateH% = FTime% \ 2048%           ' Hours
    IF FIDateH% < 0% THEN
      INCR FIDateH%, 31%                ' Fix for some P.M. hours
    END IF

	hour$ = MID$(STR$(FIDATEH%),2)
	IF LEN(HOUR$)=1 THEN HOUR$="0"+HOUR$

    FIDateM% = (FTime% AND 2047%) \ 32% ' Minutes
	MINUTES$ = MID$(STR$(FIDATEM%),2)
	IF LEN(MINUTES$)=1 THEN MINUTES$="0"+MINUTES$

    FIDateS%  = FTime% AND 31%           ' Seconds
	SECONDS$ = MID$(STR$(FIDATES%),2)
	IF LEN(SECONDS$)=1 THEN SECONDS$="0"+SECONDS$

    FILETIME$=HOUR$+":"+MINUTES$+":"+SECONDS$


    FIDateY% = (FDate% \ 512%) + 80%    ' Year
	YEARS$ = MID$(STR$(FIDATEY%),2)
	IF LEN(YEARS$)=1 THEN YEARS$="0"+YEARS$

    FIDateM% = (Fdate% AND 511%) \ 32%  ' Month
	MONTHS$ = MID$(STR$(FIDATEM%),2)
	IF LEN(MONTHS$)=1 THEN MONTHS$="0"+MONTHS$

    FIDateD%  = FDate% AND 31%           ' Day
	DAYS$ = MID$(STR$(FIDATED%),2)
	IF LEN(DAYS$)=1 THEN DAYS$="0"+DAYS$

    FILEDATE$=MONTHS$+"-"+DAYS$+"-"+YEARS$

'	FileInfo$(LowB%)=FF$+SPACE$(12-LEN(FF$))+" "+FILEDATE$+" "+FILETIME$+STR$(FISIZE&)

	FileInfo$(LowB%)=USING$("\          \",FF$)+"  "+USING$("#######",FISIZE&)+"  "+FILEDATE$+"  "+FILETIME$

    INCR LowB%

'
'   If not the last entry in the array read another directory entry.
'

    IF LowB% <= UpprB% THEN
      FF$ = DIR$
    END IF
  WEND

  NumFiles% = LowB% - LBOUND(FileInfo$(1))            ' Calculate number of
                                                      ' files found.

	IF UCASE$(S$)="Y" THEN ARRAY SORT FileInfo$() FOR NUMFILES%

END SUB
