$compile unit

$error all-
$lib all-

defint a-z

'If file already exist it will not be copied
'if successful copyfile%=1 else an error occured

'copyfile%(source filename,destination filename)

'declare function copyfile%(string,string)

'cls
'FF$=DIR$("*.bas")
'COPY1%=copyfile%(FF$,"b:\"+FF$)
'DO WHILE FF$ <> ""
'	FF$=DIR$
'        incr a
'        print ff$,a
'	if ff$<>"" then COPY1%=copyfile%(FF$,"b:\"+FF$)
'wend
'print copy1%
'end



FUNCTION copyfile%(filename1$,filename2$)  Public

local segment1&,segment2&,segment3&,where1&,where2&,where3&,_
      bytestoread%,bytesread%,handle1%,handle2%,buffer$


  filespec1$=filename1$+CHR$(0)		'make filename1 as asciiz string
  segment1&=STRSEG(filespec1$)		'get memory segment of filename1
  where1&=STRPTR(filespec1$)		'get memory offset of filename1
  filespec2$=filename2$+CHR$(0)         'make filename2 an asciiz string
  segment2&=STRSEG(filespec2$)		'get memory segment of filename2
  where2&=STRPTR(filespec2$)		'get memory offset of filename2
  buffer$=SPACE$(1024)+CHR$(0)		'define a 1k buffer area
  where3&=STRPTR(buffer$)		'get memory offset of buffer
  segment3&=STRSEG(buffer$)		'get memory segment of buffer
  copyfile%=1				'set successful operation
  bytestoread%=1024			'assign number of bytes to read
  bytesread%=1024			'assign number of bytes read
  REG 1, &H3D00                         'AH=3Dh open file function
  REG 4, where1&			'DX=memory offset of string
  REG 8, segment1&			'DS=memory segment of string
  CALL INTERRUPT &H21			'int 21h
  IF (REG(0) AND 1)<>0 THEN		'if flags register is 0 then open
    copyfile%=2				'was successful, if not an error is
    EXIT FUNCTION			'returned to your program
  END IF                                'and the function is exited
  handle1%=REG(1)			'AX contains the file handle
  REG 1, &H5B00				'AH=5Bh create/open file function
  REG 3, &H0000				'CX=0 normal file attribute
  REG 4, where2&			'DX=memory offset of string
  REG 8, segment2&			'DS=memory segment of string
  CALL INTERRUPT &H21			'int 21h
  IF (REG(0) AND 1)<>0 THEN		'if flags register is 0 then create
    copyfile%=3				'was successful, if not an error is
    REG 2, handle1%                     'returned to your program, the open
    REG 1, &H3E00			'file is closed and the function
    CALL INTERRUPT &H21			'exited
    EXIT FUNCTION
  END IF
  handle2%=REG(1)			'AX contains the file handle
  WHILE bytesread%=bytestoread%         'when bytes read <> bytes to read
    REG 1, &H3F00			'the end of the file has been reached
    REG 2, handle1%                     'AH=3Fh file read function, BX=file
    REG 3, bytestoread%			'handle, CX=bytes to read
    REG 4, where3&			'DX=memory offset of buffer
    REG 8, segment3&			'DS=memory segment of buffer
    CALL INTERRUPT &H21			'int 21h
    IF (REG(0) AND 1)<>0 THEN           'if flags register is 0 then the
      copyfile%=4			'read was successful, if not the open
      REG 2, handle1%			'files are closed and an error is
      REG 1, &H3E00			'returned to your program, the WHILE
      CALL INTERRUPT &H21		'WEND loop is exited
      REG 2, handle2%
      REG 1, &H3E00
      CALL INTERRUPT &H21
      EXIT LOOP
    END IF
    REG 2, handle2%                     'BX=file handle
    REG 3, REG(1)                       'CX=AX from previous call which
    REG 4, where3&			'contains the number of bytes read
    REG 8, segment3&                    'DX=memory offset of buffer,DS=memory
    REG 1, &H4000			'segment of buffer,AH=40h file write
    CALL INTERRUPT &H21			'int 21h
    IF (REG(0) AND 1)<>0 THEN		'if flags register is 0 then write was
      copyfile%=5			'successful, if not open files are
      REG 2, handle1%			'closed and an error is returned to
      REG 1, &H3E00			'your program
      CALL INTERRUPT &H21
      REG 2, handle2%
      REG 1, &H3E00
      CALL INTERRUPT &H21
      EXIT LOOP                         'WHILE/WEND loop is exited
    END IF
    bytesread%=REG(1)                   'AX=number of bytes written which
  WEND                                  'since we are here is the same as the
					'number of bytes read
  REG 2, handle1%			'BX=file handle
  REG 1, &H3E00                         'AH=3Eh file close function
  CALL INTERRUPT &H21			'int 21h
  REG 2, handle2%                       'BX=file handle
  REG 1, &H3E00				'AH=3Eh file close function
  CALL INTERRUPT &H21			'int 21h
END FUNCTION