$compile unit

$error all-
$lib all-

defint a-z


'Extremely fast routine to grab all the directories in a tree and put them
'into an array.  Uses the FileAttrib% and GetDTA routines.

SUB GETTREE(DRIVE$,TMP$(),CUR%) PUBLIC

LastRec%=1
Cur%=1

IF INSTR(DRIVE$,":")=0 THEN
	Tmp$(1)=DRIVE$+":"+"\"
ELSE
	Tmp$(1)=DRIVE$+"\"
END IF

GetPaths:

  Path$=Tmp$(Cur%)
  Tmp$=DIR$(Path$+"*.*",16)
  WHILE Tmp$<>""
    IF (FileAttrib% AND 16)=16 THEN
      INCR LastRec%
      Tmp$(LastRec%)=Path$+Tmp$+"\"
    END IF
    Tmp$=DIR$
  WEND
  INCR CUR%
  IF Tmp$(Cur%)<>"" THEN
	GOTO GetPaths
  ELSE
	DECR CUR%
  END IF

  ARRAY SORT Tmp$(1) FOR Cur%

END SUB


FUNCTION FileAttrib% PUBLIC
  CALL GetDTA(DtaSeg%, DtaOfs%)   'Get DTA address. (See SUB GetDTA
				  '                  in this unit.)
  DEF SEG=DtaSeg%                 'Set segment to DTA address segment.
    FileAttrib%=PEEK(DtaOfs%+21)  'Use PEEK to retrieve attribute byte.
  DEF SEG                         'Return previous value of segment.
END FUNCTION


SUB GetDTA(DtaSeg%, DtaOfs%) PUBLIC
  REG 1, &h2F00            ' Set function number to 47.
  CALL INTERRUPT &h21      ' Call interrupt 33 (Hex 21).
  DtaSeg%=REG(9)           ' Register 9 contains Segment of DTA address.
  DtaOfs%=REG(2)           ' Register 2 contains Offset of DTA address
END SUB